// DO NOT EDIT.
//
// Generated by the Swift generator plugin for the protocol buffer compiler.
// Source: tensorflow/core/util/event.proto
//
// For information on using the generated types, please see the documenation:
//   https://github.com/apple/swift-protobuf/

import Foundation
import SwiftProtobuf

// If the compiler emits an error on this type, it is because this file
// was generated by a version of the `protoc` Swift plug-in that is
// incompatible with the version of SwiftProtobuf to which you are linking.
// Please ensure that your are building against the same version of the API
// that was used to generate this file.
fileprivate struct _GeneratedWithProtocGenSwiftVersion: SwiftProtobuf.ProtobufAPIVersionCheck {
  struct _2: SwiftProtobuf.ProtobufAPIVersion_2 {}
  typealias Version = _2
}

/// Protocol buffer representing an event that happened during
/// the execution of a Brain model.
public struct Tensorflow_Event: SwiftProtobuf.Message {
  public static let protoMessageName: String = _protobuf_package + ".Event"

  /// Timestamp of the event.
  var wallTime: Double {
    get {return _storage._wallTime}
    set {_uniqueStorage()._wallTime = newValue}
  }

  /// Global step of the event.
  var step: Int64 {
    get {return _storage._step}
    set {_uniqueStorage()._step = newValue}
  }

  var what: OneOf_What? {
    get {return _storage._what}
    set {_uniqueStorage()._what = newValue}
  }

  /// An event file was started, with the specified version.
  /// This is use to identify the contents of the record IO files
  /// easily.  Current version is "brain.Event:2".  All versions
  /// start with "brain.Event:".
  var fileVersion: String {
    get {
      if case .fileVersion(let v)? = _storage._what {return v}
      return String()
    }
    set {_uniqueStorage()._what = .fileVersion(newValue)}
  }

  /// An encoded version of a GraphDef.
  var graphDef: Data {
    get {
      if case .graphDef(let v)? = _storage._what {return v}
      return SwiftProtobuf.Internal.emptyData
    }
    set {_uniqueStorage()._what = .graphDef(newValue)}
  }

  /// A summary was generated.
  var summary: Tensorflow_Summary {
    get {
      if case .summary(let v)? = _storage._what {return v}
      return Tensorflow_Summary()
    }
    set {_uniqueStorage()._what = .summary(newValue)}
  }

  /// The user output a log message. Not all messages are logged, only ones
  /// generated via the Python tensorboard_logging module.
  var logMessage: Tensorflow_LogMessage {
    get {
      if case .logMessage(let v)? = _storage._what {return v}
      return Tensorflow_LogMessage()
    }
    set {_uniqueStorage()._what = .logMessage(newValue)}
  }

  /// The state of the session which can be used for restarting after crashes.
  var sessionLog: Tensorflow_SessionLog {
    get {
      if case .sessionLog(let v)? = _storage._what {return v}
      return Tensorflow_SessionLog()
    }
    set {_uniqueStorage()._what = .sessionLog(newValue)}
  }

  /// The metadata returned by running a session.run() call.
  var taggedRunMetadata: Tensorflow_TaggedRunMetadata {
    get {
      if case .taggedRunMetadata(let v)? = _storage._what {return v}
      return Tensorflow_TaggedRunMetadata()
    }
    set {_uniqueStorage()._what = .taggedRunMetadata(newValue)}
  }

  /// An encoded version of a MetaGraphDef.
  var metaGraphDef: Data {
    get {
      if case .metaGraphDef(let v)? = _storage._what {return v}
      return SwiftProtobuf.Internal.emptyData
    }
    set {_uniqueStorage()._what = .metaGraphDef(newValue)}
  }

  public var unknownFields = SwiftProtobuf.UnknownStorage()

  enum OneOf_What: Equatable {
    /// An event file was started, with the specified version.
    /// This is use to identify the contents of the record IO files
    /// easily.  Current version is "brain.Event:2".  All versions
    /// start with "brain.Event:".
    case fileVersion(String)
    /// An encoded version of a GraphDef.
    case graphDef(Data)
    /// A summary was generated.
    case summary(Tensorflow_Summary)
    /// The user output a log message. Not all messages are logged, only ones
    /// generated via the Python tensorboard_logging module.
    case logMessage(Tensorflow_LogMessage)
    /// The state of the session which can be used for restarting after crashes.
    case sessionLog(Tensorflow_SessionLog)
    /// The metadata returned by running a session.run() call.
    case taggedRunMetadata(Tensorflow_TaggedRunMetadata)
    /// An encoded version of a MetaGraphDef.
    case metaGraphDef(Data)

    static func ==(lhs: Tensorflow_Event.OneOf_What, rhs: Tensorflow_Event.OneOf_What) -> Bool {
      switch (lhs, rhs) {
      case (.fileVersion(let l), .fileVersion(let r)): return l == r
      case (.graphDef(let l), .graphDef(let r)): return l == r
      case (.summary(let l), .summary(let r)): return l == r
      case (.logMessage(let l), .logMessage(let r)): return l == r
      case (.sessionLog(let l), .sessionLog(let r)): return l == r
      case (.taggedRunMetadata(let l), .taggedRunMetadata(let r)): return l == r
      case (.metaGraphDef(let l), .metaGraphDef(let r)): return l == r
      default: return false
      }
    }
  }

  public init() {}

  /// Used by the decoding initializers in the SwiftProtobuf library, not generally
  /// used directly. `init(serializedData:)`, `init(jsonUTF8Data:)`, and other decoding
  /// initializers are defined in the SwiftProtobuf library. See the Message and
  /// Message+*Additions` files.
  public mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    _ = _uniqueStorage()
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      while let fieldNumber = try decoder.nextFieldNumber() {
        switch fieldNumber {
        case 1: try decoder.decodeSingularDoubleField(value: &_storage._wallTime)
        case 2: try decoder.decodeSingularInt64Field(value: &_storage._step)
        case 3:
          if _storage._what != nil {try decoder.handleConflictingOneOf()}
          var v: String?
          try decoder.decodeSingularStringField(value: &v)
          if let v = v {_storage._what = .fileVersion(v)}
        case 4:
          if _storage._what != nil {try decoder.handleConflictingOneOf()}
          var v: Data?
          try decoder.decodeSingularBytesField(value: &v)
          if let v = v {_storage._what = .graphDef(v)}
        case 5:
          var v: Tensorflow_Summary?
          if let current = _storage._what {
            try decoder.handleConflictingOneOf()
            if case .summary(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._what = .summary(v)}
        case 6:
          var v: Tensorflow_LogMessage?
          if let current = _storage._what {
            try decoder.handleConflictingOneOf()
            if case .logMessage(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._what = .logMessage(v)}
        case 7:
          var v: Tensorflow_SessionLog?
          if let current = _storage._what {
            try decoder.handleConflictingOneOf()
            if case .sessionLog(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._what = .sessionLog(v)}
        case 8:
          var v: Tensorflow_TaggedRunMetadata?
          if let current = _storage._what {
            try decoder.handleConflictingOneOf()
            if case .taggedRunMetadata(let m) = current {v = m}
          }
          try decoder.decodeSingularMessageField(value: &v)
          if let v = v {_storage._what = .taggedRunMetadata(v)}
        case 9:
          if _storage._what != nil {try decoder.handleConflictingOneOf()}
          var v: Data?
          try decoder.decodeSingularBytesField(value: &v)
          if let v = v {_storage._what = .metaGraphDef(v)}
        default: break
        }
      }
    }
  }

  /// Used by the encoding methods of the SwiftProtobuf library, not generally
  /// used directly. `Message.serializedData()`, `Message.jsonUTF8Data()`, and
  /// other serializer methods are defined in the SwiftProtobuf library. See the
  /// `Message` and `Message+*Additions` files.
  public func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    try withExtendedLifetime(_storage) { (_storage: _StorageClass) in
      if _storage._wallTime != 0 {
        try visitor.visitSingularDoubleField(value: _storage._wallTime, fieldNumber: 1)
      }
      if _storage._step != 0 {
        try visitor.visitSingularInt64Field(value: _storage._step, fieldNumber: 2)
      }
      switch _storage._what {
      case .fileVersion(let v)?:
        try visitor.visitSingularStringField(value: v, fieldNumber: 3)
      case .graphDef(let v)?:
        try visitor.visitSingularBytesField(value: v, fieldNumber: 4)
      case .summary(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 5)
      case .logMessage(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 6)
      case .sessionLog(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 7)
      case .taggedRunMetadata(let v)?:
        try visitor.visitSingularMessageField(value: v, fieldNumber: 8)
      case .metaGraphDef(let v)?:
        try visitor.visitSingularBytesField(value: v, fieldNumber: 9)
      case nil: break
      }
    }
    try unknownFields.traverse(visitor: &visitor)
  }

  fileprivate var _storage = _StorageClass.defaultInstance
}

/// Protocol buffer used for logging messages to the events file.
public struct Tensorflow_LogMessage: SwiftProtobuf.Message {
  public static let protoMessageName: String = _protobuf_package + ".LogMessage"

  var level: Tensorflow_LogMessage.Level = .unknown

  var message: String = String()

  public var unknownFields = SwiftProtobuf.UnknownStorage()

  enum Level: SwiftProtobuf.Enum {
    typealias RawValue = Int
    case unknown // = 0

    /// Note: The logging level 10 cannot be named DEBUG. Some software
    /// projects compile their C/C++ code with -DDEBUG in debug builds. So the
    /// C++ code generated from this file should not have an identifier named
    /// DEBUG.
    case debugging // = 10
    case info // = 20
    case warn // = 30
    case error // = 40
    case fatal // = 50
    case UNRECOGNIZED(Int)

    init() {
      self = .unknown
    }

    init?(rawValue: Int) {
      switch rawValue {
      case 0: self = .unknown
      case 10: self = .debugging
      case 20: self = .info
      case 30: self = .warn
      case 40: self = .error
      case 50: self = .fatal
      default: self = .UNRECOGNIZED(rawValue)
      }
    }

    var rawValue: Int {
      switch self {
      case .unknown: return 0
      case .debugging: return 10
      case .info: return 20
      case .warn: return 30
      case .error: return 40
      case .fatal: return 50
      case .UNRECOGNIZED(let i): return i
      }
    }

  }

  public init() {}

  /// Used by the decoding initializers in the SwiftProtobuf library, not generally
  /// used directly. `init(serializedData:)`, `init(jsonUTF8Data:)`, and other decoding
  /// initializers are defined in the SwiftProtobuf library. See the Message and
  /// Message+*Additions` files.
  public mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    while let fieldNumber = try decoder.nextFieldNumber() {
      switch fieldNumber {
      case 1: try decoder.decodeSingularEnumField(value: &self.level)
      case 2: try decoder.decodeSingularStringField(value: &self.message)
      default: break
      }
    }
  }

  /// Used by the encoding methods of the SwiftProtobuf library, not generally
  /// used directly. `Message.serializedData()`, `Message.jsonUTF8Data()`, and
  /// other serializer methods are defined in the SwiftProtobuf library. See the
  /// `Message` and `Message+*Additions` files.
  public func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    if self.level != .unknown {
      try visitor.visitSingularEnumField(value: self.level, fieldNumber: 1)
    }
    if !self.message.isEmpty {
      try visitor.visitSingularStringField(value: self.message, fieldNumber: 2)
    }
    try unknownFields.traverse(visitor: &visitor)
  }
}

/// Protocol buffer used for logging session state.
public struct Tensorflow_SessionLog: SwiftProtobuf.Message {
  public static let protoMessageName: String = _protobuf_package + ".SessionLog"

  var status: Tensorflow_SessionLog.SessionStatus = .statusUnspecified

  /// This checkpoint_path contains both the path and filename.
  var checkpointPath: String = String()

  var msg: String = String()

  public var unknownFields = SwiftProtobuf.UnknownStorage()

  enum SessionStatus: SwiftProtobuf.Enum {
    typealias RawValue = Int
    case statusUnspecified // = 0
    case start // = 1
    case stop // = 2
    case checkpoint // = 3
    case UNRECOGNIZED(Int)

    init() {
      self = .statusUnspecified
    }

    init?(rawValue: Int) {
      switch rawValue {
      case 0: self = .statusUnspecified
      case 1: self = .start
      case 2: self = .stop
      case 3: self = .checkpoint
      default: self = .UNRECOGNIZED(rawValue)
      }
    }

    var rawValue: Int {
      switch self {
      case .statusUnspecified: return 0
      case .start: return 1
      case .stop: return 2
      case .checkpoint: return 3
      case .UNRECOGNIZED(let i): return i
      }
    }

  }

  public init() {}

  /// Used by the decoding initializers in the SwiftProtobuf library, not generally
  /// used directly. `init(serializedData:)`, `init(jsonUTF8Data:)`, and other decoding
  /// initializers are defined in the SwiftProtobuf library. See the Message and
  /// Message+*Additions` files.
  public mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    while let fieldNumber = try decoder.nextFieldNumber() {
      switch fieldNumber {
      case 1: try decoder.decodeSingularEnumField(value: &self.status)
      case 2: try decoder.decodeSingularStringField(value: &self.checkpointPath)
      case 3: try decoder.decodeSingularStringField(value: &self.msg)
      default: break
      }
    }
  }

  /// Used by the encoding methods of the SwiftProtobuf library, not generally
  /// used directly. `Message.serializedData()`, `Message.jsonUTF8Data()`, and
  /// other serializer methods are defined in the SwiftProtobuf library. See the
  /// `Message` and `Message+*Additions` files.
  public func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    if self.status != .statusUnspecified {
      try visitor.visitSingularEnumField(value: self.status, fieldNumber: 1)
    }
    if !self.checkpointPath.isEmpty {
      try visitor.visitSingularStringField(value: self.checkpointPath, fieldNumber: 2)
    }
    if !self.msg.isEmpty {
      try visitor.visitSingularStringField(value: self.msg, fieldNumber: 3)
    }
    try unknownFields.traverse(visitor: &visitor)
  }
}

/// For logging the metadata output for a single session.run() call.
public struct Tensorflow_TaggedRunMetadata: SwiftProtobuf.Message {
  public static let protoMessageName: String = _protobuf_package + ".TaggedRunMetadata"

  /// Tag name associated with this metadata.
  var tag: String = String()

  /// Byte-encoded version of the `RunMetadata` proto in order to allow lazy
  /// deserialization.
  var runMetadata: Data = SwiftProtobuf.Internal.emptyData

  public var unknownFields = SwiftProtobuf.UnknownStorage()

  public init() {}

  /// Used by the decoding initializers in the SwiftProtobuf library, not generally
  /// used directly. `init(serializedData:)`, `init(jsonUTF8Data:)`, and other decoding
  /// initializers are defined in the SwiftProtobuf library. See the Message and
  /// Message+*Additions` files.
  public mutating func decodeMessage<D: SwiftProtobuf.Decoder>(decoder: inout D) throws {
    while let fieldNumber = try decoder.nextFieldNumber() {
      switch fieldNumber {
      case 1: try decoder.decodeSingularStringField(value: &self.tag)
      case 2: try decoder.decodeSingularBytesField(value: &self.runMetadata)
      default: break
      }
    }
  }

  /// Used by the encoding methods of the SwiftProtobuf library, not generally
  /// used directly. `Message.serializedData()`, `Message.jsonUTF8Data()`, and
  /// other serializer methods are defined in the SwiftProtobuf library. See the
  /// `Message` and `Message+*Additions` files.
  public func traverse<V: SwiftProtobuf.Visitor>(visitor: inout V) throws {
    if !self.tag.isEmpty {
      try visitor.visitSingularStringField(value: self.tag, fieldNumber: 1)
    }
    if !self.runMetadata.isEmpty {
      try visitor.visitSingularBytesField(value: self.runMetadata, fieldNumber: 2)
    }
    try unknownFields.traverse(visitor: &visitor)
  }
}

// MARK: - Code below here is support for the SwiftProtobuf runtime.

fileprivate let _protobuf_package = "tensorflow"

extension Tensorflow_Event: SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .standard(proto: "wall_time"),
    2: .same(proto: "step"),
    3: .standard(proto: "file_version"),
    4: .standard(proto: "graph_def"),
    5: .same(proto: "summary"),
    6: .standard(proto: "log_message"),
    7: .standard(proto: "session_log"),
    8: .standard(proto: "tagged_run_metadata"),
    9: .standard(proto: "meta_graph_def"),
  ]

  fileprivate class _StorageClass {
    var _wallTime: Double = 0
    var _step: Int64 = 0
    var _what: Tensorflow_Event.OneOf_What?

    static let defaultInstance = _StorageClass()

    public init() {}

    init(copying source: _StorageClass) {
      _wallTime = source._wallTime
      _step = source._step
      _what = source._what
    }
  }

  fileprivate mutating func _uniqueStorage() -> _StorageClass {
    if !isKnownUniquelyReferenced(&_storage) {
      _storage = _StorageClass(copying: _storage)
    }
    return _storage
  }

  public func _protobuf_generated_isEqualTo(other: Tensorflow_Event) -> Bool {
    if _storage !== other._storage {
      let storagesAreEqual: Bool = withExtendedLifetime((_storage, other._storage)) { (_storage, other_storage) in
        if _storage._wallTime != other_storage._wallTime {return false}
        if _storage._step != other_storage._step {return false}
        if _storage._what != other_storage._what {return false}
        return true
      }
      if !storagesAreEqual {return false}
    }
    if unknownFields != other.unknownFields {return false}
    return true
  }
}

extension Tensorflow_LogMessage: SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "level"),
    2: .same(proto: "message"),
  ]

  public func _protobuf_generated_isEqualTo(other: Tensorflow_LogMessage) -> Bool {
    if self.level != other.level {return false}
    if self.message != other.message {return false}
    if unknownFields != other.unknownFields {return false}
    return true
  }
}

extension Tensorflow_LogMessage.Level: SwiftProtobuf._ProtoNameProviding {
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    0: .same(proto: "UNKNOWN"),
    10: .same(proto: "DEBUGGING"),
    20: .same(proto: "INFO"),
    30: .same(proto: "WARN"),
    40: .same(proto: "ERROR"),
    50: .same(proto: "FATAL"),
  ]
}

extension Tensorflow_SessionLog: SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "status"),
    2: .standard(proto: "checkpoint_path"),
    3: .same(proto: "msg"),
  ]

  public func _protobuf_generated_isEqualTo(other: Tensorflow_SessionLog) -> Bool {
    if self.status != other.status {return false}
    if self.checkpointPath != other.checkpointPath {return false}
    if self.msg != other.msg {return false}
    if unknownFields != other.unknownFields {return false}
    return true
  }
}

extension Tensorflow_SessionLog.SessionStatus: SwiftProtobuf._ProtoNameProviding {
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    0: .same(proto: "STATUS_UNSPECIFIED"),
    1: .same(proto: "START"),
    2: .same(proto: "STOP"),
    3: .same(proto: "CHECKPOINT"),
  ]
}

extension Tensorflow_TaggedRunMetadata: SwiftProtobuf._MessageImplementationBase, SwiftProtobuf._ProtoNameProviding {
  public static let _protobuf_nameMap: SwiftProtobuf._NameMap = [
    1: .same(proto: "tag"),
    2: .standard(proto: "run_metadata"),
  ]

  public func _protobuf_generated_isEqualTo(other: Tensorflow_TaggedRunMetadata) -> Bool {
    if self.tag != other.tag {return false}
    if self.runMetadata != other.runMetadata {return false}
    if unknownFields != other.unknownFields {return false}
    return true
  }
}
